/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportCohort type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportCohort{}

// ReportCohort struct for ReportCohort
type ReportCohort struct {
	Results []ReportCohortEntry `json:"results"`
	Total int32 `json:"total"`
}

// NewReportCohort instantiates a new ReportCohort object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportCohort(results []ReportCohortEntry, total int32) *ReportCohort {
	this := ReportCohort{}
	this.Results = results
	this.Total = total
	return &this
}

// NewReportCohortWithDefaults instantiates a new ReportCohort object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportCohortWithDefaults() *ReportCohort {
	this := ReportCohort{}
	return &this
}

// GetResults returns the Results field value
func (o *ReportCohort) GetResults() []ReportCohortEntry {
	if o == nil {
		var ret []ReportCohortEntry
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *ReportCohort) GetResultsOk() ([]ReportCohortEntry, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *ReportCohort) SetResults(v []ReportCohortEntry) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *ReportCohort) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *ReportCohort) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *ReportCohort) SetTotal(v int32) {
	o.Total = v
}

func (o ReportCohort) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportCohort) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableReportCohort struct {
	value *ReportCohort
	isSet bool
}

func (v NullableReportCohort) Get() *ReportCohort {
	return v.value
}

func (v *NullableReportCohort) Set(val *ReportCohort) {
	v.value = val
	v.isSet = true
}

func (v NullableReportCohort) IsSet() bool {
	return v.isSet
}

func (v *NullableReportCohort) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportCohort(val *ReportCohort) *NullableReportCohort {
	return &NullableReportCohort{value: val, isSet: true}
}

func (v NullableReportCohort) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportCohort) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


